Index: docsrc/version.dd
===================================================================
--- docsrc/version.dd	(revision 1179)
+++ docsrc/version.dd	(working copy)
@@ -220,30 +220,49 @@
 	all modules being compiled and imported.
 	)
 
-	$(TABLE2 Predefined Version Identifiers,
-	$(TR $(TH Version Identifier) $(TH Description))
-	$(TR $(TD $(B DigitalMars)) $(TD Digital Mars is the compiler vendor))
-	$(TR $(TD $(B X86)) $(TD Intel and AMD 32 bit processors))
-	$(TR $(TD $(B X86_64)) $(TD AMD and Intel 64 bit processors))
-	$(TR $(TD $(B Windows)) $(TD Microsoft Windows systems))
-	$(TR $(TD $(B Win32)) $(TD Microsoft 32 bit Windows systems))
-	$(TR $(TD $(B Win64)) $(TD Microsoft 64 bit Windows systems))
-	$(TR $(TD $(B linux)) $(TD All linux systems))
-$(V2
-	$(TR $(TD $(B Posix)) $(TD All linux systems))
-)
-	$(TR $(TD $(B LittleEndian)) $(TD Byte order, least significant first))
-	$(TR $(TD $(B BigEndian)) $(TD Byte order, most significant first))
-	$(TR $(TD $(B D_Coverage)) $(TD $(LINK2 code_coverage.html, Code coverage analysis) instrumentation (command line $(LINK2 dmd-windows.html#switches, switch) $(B -cov)) is being generated))
-	$(TR $(TD $(B D_Ddoc)) $(TD $(LINK2 ddoc.html, Ddoc) documentation (command line $(LINK2 dmd-windows.html#switches, switch) $(B -D)) is being generated))
-	$(TR $(TD $(B D_InlineAsm_X86)) $(TD $(LINK2 iasm.html, Inline assembler) for X86 is implemented))
-	$(TR $(TD $(B D_InlineAsm_X86_64)) $(TD $(LINK2 iasm.html, Inline assembler) for X86-64 is implemented))
-	$(TR $(TD $(B D_LP64)) $(TD Pointers are 64 bits (command line $(LINK2 dmd-windows.html#switches, switch) $(B -m64))))
-	$(TR $(TD $(B D_PIC)) $(TD Position Independent Code (command line $(LINK2 dmd-windows.html#switches, switch) $(B -fPIC)) is being generated))
-	$(V2 $(TR $(TD $(B unittest)) $(TD Unit tests are enabled (command line $(LINK2 dmd-windows.html#switches, switch) $(B -unittest)))))
-	$(V2 $(TR $(TD $(B D_Version2)) $(TD This is a D version 2 compiler)))
-	$(TR $(TD $(B none)) $(TD Never defined; used to just disable a section of code))
-	$(TR $(TD $(B all)) $(TD Always defined; used as the opposite of $(B none)))
+	$(TABLE2 Predefined Version Identifiers
+	$(TR $(TH ) $(TH Compiler Vendors) $(TH Notes))
+	$(TR $(TD $(B DigitalMars)) $(TD Digital Mars compilers) $(TD DMD only))
+	$(TR $(TD $(B LDC)) $(TD The LLVM based D compiler) $(TD LDC only))
+	$(TR $(TD $(B LLVM)) $(TD The LLVM based D compiler) $(TD LDC only))
+
+	$(TR $(TH ) $(TH CPU Architectures) $(TH &nbsp;))
+	$(TR $(TD $(B ARM)) $(TD ARM processors) $(TD LDC only))
+	$(TR $(TD $(B PPC)) $(TD PowerPC 32 bit processors) $(TD LDC only))
+	$(TR $(TD $(B PPC64)) $(TD PowerPC 64 bit processors) $(TD LDC only))
+	$(TR $(TD $(B Thumb)) $(TD Thumb processors) $(TD LDC only))
+	$(TR $(TD $(B X86)) $(TD Intel and AMD 32 bit processors) $(TD &nbsp;))
+	$(TR $(TD $(B X86_64)) $(TD AMD and Intel 64 bit processors) $(TD LDC only))
+
+	$(TR $(TH ) $(TH Operating Systems) $(TH &nbsp;))
+	$(TR $(TD $(B darwin)) $(TD Apple's OSX systems) $(TD LDC only))
+	$(V2 $(TR $(TD $(B freebsd)) $(TD All FreeBSD systems) $(TD LDC only)))
+	$(V2 $(TR $(TD $(B FreeBSD)) $(TD All FreeBSD systems) $(TD &nbsp;)))
+	$(TR $(TD $(B linux)) $(TD All linux systems) $(TD &nbsp;))
+	$(TR $(TD $(B mingw32)) $(TD mingw 32 bit systems) $(TD LDC only))
+	$(TR $(TD $(B OSX)) $(TD Apple's OSX systems) $(TD &nbsp;))
+	$(V2 $(TR $(TD $(B Posix)) $(TD All posix systems) $(TD &nbsp;)))
+	$(V2 $(TR $(TD $(B solaris)) $(TD All Solaris systems) $(TD LDC only)))
+	$(V2 $(TR $(TD $(B Solaris)) $(TD All Solaris systems) $(TD &nbsp;)))
+	$(TR $(TD $(B Windows)) $(TD Microsoft Windows systems) $(TD &nbsp;))
+	$(TR $(TD $(B Win32)) $(TD Microsoft 32 bit Windows systems) $(TD &nbsp;))
+	$(TR $(TD $(B Win64)) $(TD Microsoft 64 bit Windows systems) $(TD &nbsp;))
+
+	$(TR $(TH ) $(TH Various Features) $(TH &nbsp;))
+	$(TR $(TD $(B LittleEndian)) $(TD Byte order, least significant first) $(TD &nbsp;))
+	$(TR $(TD $(B BigEndian)) $(TD Byte order, most significant first) $(TD &nbsp;))
+	$(TR $(TD $(B D_Coverage)) $(TD $(LINK2 code_coverage.html, Code coverage analysis) instrumentation (command line $(LINK2 dmd-windows.html#switches, switch) $(B -cov)) is being generated) $(TD DMD only))
+	$(TR $(TD $(B D_Ddoc)) $(TD $(LINK2 ddoc.html, Ddoc) documentation (command line $(LINK2 dmd-windows.html#switches, switch) $(B -D)) is being generated) $(TD &nbsp;))
+	$(TR $(TD $(B D_InlineAsm_X86)) $(TD $(LINK2 iasm.html, Inline assembler) for X86 is implemented) $(TD &nbsp;))
+	$(TR $(TD $(B D_InlineAsm_X86_64)) $(TD $(LINK2 iasm.html, Inline assembler) for X86-64 is implemented) $(TD LDC only))
+	$(V2 $(TR $(TD $(B D_NET)) $(TD The .NET D compiler) $(TD &nbsp;)))
+	$(TR $(TD $(B D_LP64)) $(TD Pointers are 64 bits (command line $(LINK2 dmd-windows.html#switches, switch) $(B -m64))) $(TD &nbsp;))
+	$(TR $(TD $(B D_PIC)) $(TD Position Independent Code (command line $(LINK2 dmd-windows.html#switches, switch) $(B -fPIC)) is being generated) $(TD &nbsp;))
+	$(TR $(TD $(B LLVM64)) $(TD LLVM generating 64 bit output) $(TD LDC only))
+	$(V2 $(TR $(TD $(B D_Version2)) $(TD This is a D version 2 compiler) $(TD &nbsp;)))
+	$(V2 $(TR $(TD $(B unittest)) $(TD Unit tests are enabled (command line $(LINK2 dmd-windows.html#switches, switch) $(B -unittest))) $(TD &nbsp;)))
+	$(TR $(TD $(B none)) $(TD Never defined; used to just disable a section of code) $(TD &nbsp;))
+	$(TR $(TD $(B all)) $(TD Always defined; used as the opposite of $(B none)) $(TD &nbsp;))
 	)
 
 	$(P Others will be added as they make sense and new implementations appear.